=== Makefile ===
# Top level Makefile for ROOT System
# Copyright (c) 2000 Rene Brun and Fons Rademakers
#
# Author: Fons Rademakers, 29/2/2000


##### Check version of GNU make #####

MAKE_VERSION_MAJOR := $(word 1,$(subst ., ,$(MAKE_VERSION)))
MAKE_VERSION_MINOR := $(shell echo $(word 2,$(subst ., ,$(MAKE_VERSION))) | \
                              sed 's/\([0-9][0-9]*\).*/\1/')
MAKE_VERSION_MAJOR ?= 0
MAKE_VERSION_MINOR ?= 0
ORDER_ := $(shell test $(MAKE_VERSION_MAJOR) -gt 3 || \
                  test $(MAKE_VERSION_MAJOR) -eq 3 && \
                  test $(MAKE_VERSION_MINOR) -ge 80 && echo '|')

##### Include path/location macros (result of ./configure) #####

include config/Makefile.config

##### Prevent propagation of user flags to autoconf        #####
##### configure  in bundled autotools projects since we    #####
##### are trying to set all compiler flags ourself and     #####
##### including them could lead to e.g. conflicting 32/64  #####
##### bit build options.
CONFIG_SITE =

##### Include compiler overrides specified via ./configure #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####
##### Included before Makefile.$ARCH only because of f77   #####
##### if case has to be processed                          #####

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include config/Makefile.comp
endif
ifeq ($(MAKECMDGOALS),clean)
include config/Makefile.comp
endif

##### Include machine dependent macros                     #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####

ifndef ROOT_SRCDIR
$(error Please run ./configure first)
endif

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include $(ROOT_SRCDIR)/config/Makefile.$(ARCH)
endif
ifeq ($(MAKECMDGOALS),clean)
include $(ROOT_SRCDIR)/config/Makefile.$(ARCH)
endif

##### Include compiler overrides specified via ./configure #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include config/Makefile.comp
endif
ifeq ($(MAKECMDGOALS),clean)
include config/Makefile.comp
endif

##### Include library dependencies for explicit linking #####

MAKEFILEDEP = $(ROOT_SRCDIR)/config/Makefile.depend
include $(MAKEFILEDEP)

##### Allow local macros #####

-include MyConfig.mk

##### Modules to build #####

MODULES       = build cint/cint core/metautils core/pcre core/clib core/utils \
                core/textinput core/base core/cont core/meta core/thread \
                io/io math/mathcore net/net core/zip core/lzma math/matrix \
                core/newdelete hist/hist tree/tree graf2d/freetype \
                graf2d/mathtext graf2d/graf graf2d/gpad graf3d/g3d \
                gui/gui math/minuit hist/histpainter tree/treeplayer \
                gui/ged tree/treeviewer math/physics graf2d/postscript \
                core/rint html montecarlo/eg \
                geom/geom geom/geompainter montecarlo/vmc \
                math/fumili math/mlp math/quadp net/auth gui/guibuilder io/xml \
                math/foam math/splot math/smatrix io/sql \
                geom/geombuilder hist/spectrum hist/spectrumpainter \
                gui/fitpanel proof/proof proof/proofplayer \
                gui/sessionviewer gui/guihtml gui/recorder

ifeq ($(ARCH),win32)
MODULES      += core/winnt graf2d/win32gdk
MODULES      := $(filter-out core/newdelete,$(MODULES))
SYSTEML       = $(WINNTL)
SYSTEMO       = $(WINNTO)
SYSTEMDO      = $(WINNTDO)
else
ifeq ($(ARCH),win32gcc)
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
else
ifeq ($(ARCH),win64gcc)
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
else
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
endif
endif
endif
ifeq ($(PLATFORM),ios)
MODULES      += graf2d/ios
endif
ifeq ($(BUILDVC),yes)
MODULES      += math/vc
endif
ifeq ($(BUILDVDT),yes)
MODULES      += math/vdt
endif
ifeq ($(BUILDCOCOA),yes)
MODULES      += graf2d/quartz
MODULES      += graf2d/cocoa
MODULES      += core/macosx
MODULES      += rootx
SYSTEML      += $(MACOSXL)
SYSTEMO      += $(MACOSXO)
SYSTEMDO     += $(MACOSXDO)
CORELIBEXTRA += -framework Cocoa
endif
ifeq ($(BUILDX11),yes)
MODULES      += graf2d/x11 graf2d/x11ttf graf3d/x3d rootx
endif
ifeq ($(BUILDGL),yes)
ifeq ($(BUILDFTGL),yes)
MODULES      += graf3d/ftgl
endif
ifeq ($(BUILDGLEW),yes)
MODULES      += graf3d/glew
endif
MODULES      += graf3d/gl graf3d/eve graf3d/gviz3d
endif
ifeq ($(BUILDMYSQL),yes)
MODULES      += sql/mysql
endif
ifeq ($(BUILDORACLE),yes)
MODULES      += sql/oracle
endif
ifeq ($(BUILDPGSQL),yes)
MODULES      += sql/pgsql
endif
ifeq ($(BUILDSQLITE),yes)
MODULES      += sql/sqlite
endif
ifeq ($(BUILDSAPDB),yes)
MODULES      += sql/sapdb
endif
ifeq ($(BUILDODBC),yes)
MODULES      += sql/odbc
endif
ifeq ($(BUILDRFIO),yes)
MODULES      += io/rfio
endif
ifeq ($(BUILDCASTOR),yes)
MODULES      += io/castor
endif
ifeq ($(BUILDDCAP),yes)
MODULES      += io/dcache
endif
ifeq ($(BUILDDAVIX),yes)
MODULES      += net/davix
endif
ifeq ($(BUILDGFAL),yes)
MODULES      += io/gfal
endif
ifeq ($(BUILDGLITE),yes)
MODULES      += net/glite
endif
ifeq ($(BUILDBONJOUR),yes)
MODULES      += net/bonjour
endif
ifeq ($(BUILDCHIRP),yes)
MODULES      += io/chirp
endif
ifeq ($(BUILDHDFS),yes)
MODULES      += io/hdfs
endif
ifeq ($(BUILDMEMSTAT),yes)
MODULES      += misc/memstat
endif
ifeq ($(BUILDASIMAGE),yes)
MODULES      += graf2d/asimage
ifeq ($(BUILDFITSIO),yes)
MODULES      += graf2d/fitsio
endif
endif
ifeq ($(BUILDFPYTHIA6),yes)
MODULES      += montecarlo/pythia6
endif
ifeq ($(BUILDFPYTHIA8),yes)
MODULES      += montecarlo/pythia8
endif
ifeq ($(BUILDFFTW3),yes)
MODULES      += math/fftw
endif
ifeq ($(BUILDGVIZ),yes)
MODULES      += graf2d/gviz
endif
ifeq ($(BUILDPYTHON),yes)
MODULES      += bindings/pyroot
endif
ifeq ($(BUILDRUBY),yes)
MODULES      += bindings/ruby
endif
ifeq ($(BUILDXML),yes)
MODULES      += io/xmlparser
endif
ifeq ($(BUILDQT),yes)
MODULES      += graf2d/qt gui/qtroot
endif
ifeq ($(BUILDQTGSI),yes)
MODULES      += gui/qtgsi
endif
ifeq ($(BUILDGENVECTOR),yes)
MODULES      += math/genvector
endif
ifeq ($(BUILDMATHMORE),yes)
MODULES      += math/mathmore
endif
ifeq ($(BUILDREFLEX),yes)
# put reflex right in front of CINT; CINT needs it
MODULES      := $(subst cint/cint,cint/reflex cint/cint,$(MODULES))
endif
ifeq ($(BUILDMINUIT2),yes)
MODULES      += math/minuit2
endif
ifeq ($(BUILDUNURAN),yes)
MODULES      += math/unuran
endif
ifeq ($(BUILDCLING),yes)
# put cling right behind of CINT; e.g. UTILS need it
MODULES      := $(subst cint/cint,cint/cint cint/cling,$(MODULES))
endif
ifeq ($(BUILDCINTEX),yes)
MODULES      += cint/cintex
endif
ifeq ($(BUILDROOFIT),yes)
MODULES      += roofit/roofitcore roofit/roofit roofit/roostats
ifeq ($(BUILDXML),yes)
MODULES      += roofit/histfactory
endif
endif
ifeq ($(BUILDGDML),yes)
MODULES      += geom/gdml
endif
ifeq ($(BUILDTABLE),yes)
MODULES      += misc/table
endif
ifeq ($(BUILDSRPUTIL),yes)
MODULES      += net/srputils
endif
ifeq ($(BUILDKRB5),yes)
MODULES      += net/krb5auth
endif
ifeq ($(BUILDLDAP),yes)
MODULES      += net/ldap
endif
ifeq ($(BUILDMONALISA),yes)
MODULES      += net/monalisa
endif
ifeq ($(BUILDGLOBUS),yes)
MODULES      += net/globusauth
endif
ifneq ($(F77),)
MODULES      += misc/minicern hist/hbook
endif
ifeq ($(HASXRD),yes)
MODULES      += net/netx
ifeq ($(BUILDNETXNG),yes)
MODULES      += net/netxng
endif
ifeq ($(BUILDALIEN),yes)
MODULES      += net/alien
endif
endif
ifneq ($(ARCH),win32)
MODULES      += net/rpdutils net/rootd proof/proofd proof/pq2 proof/proofbench
endif
ifeq ($(BUILDTMVA),yes)
MODULES      += tmva math/genetic
endif
ifeq ($(HASXRD),yes)
ifeq ($(BUILDXRDCLT),no)
ifeq ($(ARCH),win32)
MODULES      += proof/proofd
endif
MODULES      += proof/proofx
endif
endif
ifeq ($(BUILDAFDSMGRD),yes)
MODULES      += proof/afdsmgrd
endif
ifeq ($(BUILDHTTP),yes)
MODULES      += net/http
endif

-include MyModules.mk   # allow local modules

ifneq ($(findstring $(MAKECMDGOALS),distclean maintainer-clean),)
MODULES      += core/unix core/winnt graf2d/x11 graf2d/x11ttf \
                graf3d/gl graf3d/ftgl graf3d/glew io/rfio io/castor \
                montecarlo/pythia6 montecarlo/pythia8 misc/table \
                sql/mysql sql/pgsql sql/sqlite sql/sapdb net/srputils \
                rootx net/rootd io/dcache io/chirp hist/hbook graf2d/asimage \
                net/ldap net/krb5auth net/rpdutils net/globusauth \
                bindings/pyroot bindings/ruby io/gfal misc/minicern \
                graf2d/qt gui/qtroot gui/qtgsi net/netx net/netxng net/alien \
                proof/proofd proof/proofx proof/pq2 graf3d/x3d net/davix \
                sql/oracle io/xmlparser math/mathmore cint/reflex cint/cintex \
                tmva math/genetic io/hdfs graf2d/fitsio roofit/roofitcore \
                roofit/roofit roofit/roostats roofit/histfactory \
                math/minuit2 net/monalisa math/fftw sql/odbc math/unuran \
                geom/gdml graf3d/eve net/glite misc/memstat \
                math/genvector net/bonjour graf3d/gviz3d graf2d/gviz \
                proof/proofbench proof/afdsmgrd cint/cling graf2d/ios \
                graf2d/quartz graf2d/cocoa core/macosx net/http
MODULES      := $(sort $(MODULES))   # removes duplicates
endif

MODULES      += main   # must be last, $(ALLLIBS) must be fully formed

ifeq ($(BUILDTOOLS),yes)
MODULES       = build cint/cint core/metautils core/clib core/base core/meta \
                core/utils
endif

##### ROOT libraries #####

LPATH         = lib

ifneq ($(PLATFORM),win32)
RPATH        := -L$(LPATH)
CINTLIBS     := -lCint
NEWLIBS      := -lNew
BOOTLIBS     := -lCore -lCint
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBS     += -lCintex -lReflex
endif
ifeq ($(BUILDCLING),yes)
BOOTLIBS     += -lCling
endif
ROOTLIBS     := -lRIO -lHist -lGraf -lGraf3d -lGpad -lTree \
                -lMatrix -lNet -lThread -lMathCore $(BOOTLIBS)
RINTLIBS     := -lRint
else
CINTLIBS     := $(LPATH)/libCint.lib
NEWLIBS      := $(LPATH)/libNew.lib
BOOTLIBS     := $(LPATH)/libCore.lib $(LPATH)/libCint.lib
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBS     += $(LPATH)/libCintex.lib $(LPATH)/libReflex.lib
endif
ifeq ($(BUILDCLING),yes)
BOOTLIBS     += $(LPATH)/libCling.lib
endif
ROOTLIBS     := $(LPATH)/libRIO.lib $(LPATH)/libHist.lib \
                $(LPATH)/libGraf.lib $(LPATH)/libGraf3d.lib \
                $(LPATH)/libGpad.lib $(LPATH)/libTree.lib \
                $(LPATH)/libMatrix.lib $(LPATH)/libNet.lib \
                $(LPATH)/libThread.lib $(LPATH)/libMathCore.lib \
                $(BOOTLIBS)
RINTLIBS     := $(LPATH)/libRint.lib
endif

ROOTALIB     := $(LPATH)/libRoot.a
ROOTA        := bin/roota
PROOFSERVA   := bin/proofserva

# ROOTLIBSDEP is intended to match the content of ROOTLIBS
BOOTLIBSDEP   = $(ORDER_) $(CORELIB) $(CINTLIB)
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBSDEP  += $(CINTEXLIB) $(REFLEXLIB)
endif
ROOTLIBSDEP   = $(BOOTLIBSDEP) $(MATHCORELIB) $(IOLIB) $(NETLIB) $(HISTLIB) \
                $(GRAFLIB) $(G3DLIB) $(GPADLIB) $(TREELIB) $(MATRIXLIB)

# Force linking of not referenced libraries
ifeq ($(FORCELINK),yes)
ifeq ($(PLATFORM),aix5)
ROOTULIBS    := -Wl,-u,.G__cpp_setupG__Net      \
                -Wl,-u,.G__cpp_setupG__IO       \
                -Wl,-u,.G__cpp_setupG__Hist     \
                -Wl,-u,.G__cpp_setupG__Graf     \
                -Wl,-u,.G__cpp_setupG__G3D      \
                -Wl,-u,.G__cpp_setupG__GPad     \
                -Wl,-u,.G__cpp_setupG__Tree     \
                -Wl,-u,.G__cpp_setupG__Thread   \
                -Wl,-u,.G__cpp_setupG__Matrix
else
ifeq ($(PLATFORM),macosx)
LDSYMPREFIX  := _
endif
