=== bindings/CMakeLists.txt ===
if(python)
  add_subdirectory(pyroot)
endif()
if(ruby)
  add_subdirectory(ruby)
endif()
