=== math/CMakeLists.txt ===
ROOT_USE_PACKAGE(math/mathcore)
ROOT_USE_PACKAGE(math/matrix)

add_subdirectory(mathcore)
if(mathmore)
  add_subdirectory(mathmore)
endif()
add_subdirectory(matrix)
add_subdirectory(minuit)
if(minuit2)
  add_subdirectory(minuit2)
endif()  
add_subdirectory(fumili)
add_subdirectory(physics)
add_subdirectory(mlp)
add_subdirectory(quadp)
add_subdirectory(foam)
add_subdirectory(smatrix)
add_subdirectory(splot)
#add_subdirectory(mathcore/test EXCLUDE_FROM_ALL)
add_subdirectory(genvector)
if(tmva) 
  add_subdirectory(genetic) 
endif()
if(unuran)
  add_subdirectory(unuran)
endif()
if(fftw3)
  add_subdirectory(fftw)
endif()
if(vc)
  if(testing)
    set(vc_tests ON)
  endif()
  set(TARGET_ARCHITECTURE auto CACHE STRING "")
  add_subdirectory(vc)
endif()

if(vdt)
  add_subdirectory(vdt)
endif()
