=== debian/changelog ===
root-system (5.34.30-0ubuntu8) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 13:00:52 +0000

root-system (5.34.30-0ubuntu7) xenial; urgency=medium

  * No-change rebuild for ruby2.3-only support.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 Mar 2016 21:15:34 +0000

root-system (5.34.30-0ubuntu6) xenial; urgency=medium

  * Rebuild against new gsl SONAME change.

 -- Michael Terry <mterry@ubuntu.com>  Tue, 08 Dec 2015 12:07:32 -0500

root-system (5.34.30-0ubuntu5) xenial; urgency=medium

  * Update for gsl_multifit_covar API changes in gsl2.

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 11 Nov 2015 21:55:45 +0000

root-system (5.34.30-0ubuntu4) xenial; urgency=medium

  * Rebuild against new gsl. Update references to libgsl0-dev to libgsl-
    dev.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 10 Nov 2015 15:07:53 +0000

root-system (5.34.30-0ubuntu3) wily; urgency=medium

  * Fix the ARM32 build.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Aug 2015 17:24:44 +0200

root-system (5.34.30-0ubuntu2) wily; urgency=medium

  * Fix configury on powerpc and ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Aug 2015 13:46:57 +0200

root-system (5.34.30-0ubuntu1) wily; urgency=medium

  * New upstream version, to build with GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Aug 2015 13:04:20 +0200

root-system (5.34.19+dfsg-1.2build1) wily; urgency=medium

  * No-change rebuild against libpytha8v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 12 Aug 2015 19:24:57 +0000
