=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

PREFIX		= /usr
SYSCONFDIR	= /etc

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_CPU    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH	     ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_SYSTEM)
DEB_BUILD_ARCH	     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)
EXTRA_LDFLAGS  := $(LDFLAGS)

ifeq ($(DEB_HOST_ARCH),ppc64el)
  CFLAGS := $(subst -O3,-O2,$(CFLAGS))
endif

export CFLAGS EXTRA_LDFLAGS DEB_HOST_MULTIARCH

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
BUILDOPT	= --build=debug
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM = -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(NUMJOBS)
endif
ifeq (hurd-i386,$(DEB_BUILD_ARCH))
MAKEFLAGS += -j1
endif
UNUR		= --enable-unuran
#ifneq (,$(findstring alpha, $(DEB_BUILD_ARCH)))
#UNUR		= --disable-unuran
#endif
#XRD		= --enable-xrootd
#ifneq (,$(findstring sparc, $(DEB_BUILD_ARCH)))
XRD		= --disable-xrootd
#endif

DTMP		= debian/tmp
PKGDOCDIR	= $(PREFIX)/share/doc/root
CINTDIR		= $(PREFIX)/lib/$(DEB_HOST_MULTIARCH)/root$(SOVERS)
ICONTHEME	= $(PREFIX)/share/icons/hicolor/48x48
CONFOPTIONS	:=--enable-bonjour				\
		  --enable-cintex				\
		  --enable-editline				\
		  --enable-explicitlink				\
		  --enable-gdml					\
		  --enable-globus				\
		  --enable-gsl-shared				\
		  --disable-gviz				\
		  --enable-fftw3				\
		  --enable-krb5					\
		  --enable-ldap					\
		  --enable-qt					\
		  --enable-qtgsi				\
		  --enable-mathcore				\
		  --enable-mathmore				\
		  --enable-memstat				\
		  --enable-minuit2				\
		  --enable-mysql				\
		  --enable-pgsql				\
		  --enable-pythia8				\
		  --enable-odbc					\
		  --enable-reflex				\
		  --enable-roofit				\
		  --enable-ruby					\
		  --enable-shadowpw				\
		  --enable-shared				\
		  --enable-soversion				\
		  --enable-sqlite				\
		  --enable-table				\
		  --disable-rpath				\
		  --disable-afs					\
		  --disable-srp					\
		  --disable-builtin-afterimage			\
		  --disable-builtin-ftgl			\
		  --disable-builtin-freetype			\
		  --disable-builtin-glew			\
		  --disable-builtin-pcre			\
		  --disable-builtin-zlib			\
		  --disable-builtin-lzma			\
		  --disable-alien				\
		  --disable-chirp				\
		  --disable-dcache				\
		  --disable-gfal				\
		  --disable-monalisa				\
		  --disable-oracle				\
		  --disable-pythia6				\
		  --disable-rfio				\
		  --disable-sapdb				\
		  --fail-on-missing				\
		  --with-globus=/usr				\
		  --with-globus-incdir=/usr/include/globus	\
		  --with-globus-libdir=/usr/lib			\
		  --with-odbc-incdir=/usr/include/iodbc		\
		  --with-pythia8-incdir=/usr/include/pythia8	\
		  $(UNUR)					\
		  $(XRD)					\
		  $(BUILDOPT)
#
# Things for the future 
#
#		  --enable-mathcore	libroot
#		  --enable-cintex	libroot
#		  --enable-reflex	libroot
#		  --with-globus=/opt/globus
#		  --disable-builtin-gsl				
#		  --disable-builtin				\

VERSION		:= $(shell head -n1 debian/changelog | cut -d' ' -f2 | tr -d '()')
MAJOR		:= $(shell echo $(VERSION) | cut -f1 -d'.')
MINOR		:= $(shell echo $(VERSION) | cut -f2 -d'.')
SOVERS		:= $(MAJOR).$(MINOR)
PKGLIST		:= $(shell ./configure $(PLATFORM) --pkglist $(CONFOPTIONS) | sed -n -e 's/packages: //p')
ESSENTIALS	:= libroot-core-dev			\
		   libroot-core				\
		   root-system-bin			\
		   root-system-common			\
		   ttf-root-installer		
PLUGINS		:= libroot-geom				\
		   libroot-graf2d-gpad			\
		   libroot-graf2d-graf			\
		   libroot-graf2d-postscript		\
		   libroot-graf3d-eve			\
		   libroot-graf3d-g3d			\
		   libroot-graf3d-gl			\
		   libroot-gui				\
		   libroot-gui-ged			\
		   libroot-hist				\
		   libroot-hist-spectrum		\
		   libroot-html				\
		   libroot-io				\
		   libroot-io-xmlparser			\
		   libroot-math-foam			\
		   libroot-math-genvector		\
		   libroot-math-mathcore		\
		   libroot-math-mathmore		\
		   libroot-math-matrix			\
		   libroot-math-minuit			\
		   libroot-math-mlp			\
		   libroot-math-quadp			\
		   libroot-math-physics			\
		   libroot-math-smatrix			\
		   libroot-math-splot			\
		   libroot-math-unuran			\
		   libroot-misc-minicern		\
		   libroot-misc-memstat			\
		   libroot-misc-table			\
		   libroot-montecarlo-eg		\
		   libroot-montecarlo-vmc		\
		   libroot-net				\
		   libroot-net-auth			\
		   libroot-net-bonjour			\
		   libroot-net-ldap			\
		   libroot-proof			\
		   libroot-proof-proofplayer		\
		   libroot-tmva				\
		   libroot-tree				\
		   libroot-tree-treeplayer		\
		   root-plugin-geom-geombuilder		\
		   root-plugin-geom-geompainter		\
		   root-plugin-graf2d-asimage		\
		   root-plugin-graf2d-qt		\
		   root-plugin-graf2d-x11		\
		   root-plugin-graf2d-gvi		\
		   root-plugin-graf3d-x3d		\
		   root-plugin-gui-fitpanel		\
		   root-plugin-gui-guibuilder		\
		   root-plugin-gui-qt			\
		   root-plugin-gui-sessionviewer	\
		   root-plugin-hist-hbook		\
		   root-plugin-hist-histpainter		\
		   root-plugin-hist-spectrumpainter	\
		   root-plugin-io-sql			\
		   root-plugin-io-xml			\
		   root-plugin-math-fftw3		\
		   root-plugin-math-fumili		\
		   root-plugin-math-minuit2		\
		   root-plugin-net-krb5			\
		   root-plugin-net-netx			\
		   root-plugin-sql-odbc			\
		   root-plugin-tree-treeviewer		\
		   root-system-proofd			\
		   root-system-doc			\
		   root-system-rootd
#		   root-plugin-graf2d-gviz
EXTRAS		:= libroot-bindings-python		\
		   libroot-roofit			\
		   libroot-bindings-ruby		\
		   root-plugin-geom-gdml		\
		   root-plugin-io-castor		\
		   root-plugin-io-chirp			\
		   root-plugin-io-dcache		\
		   root-plugin-montecarlo-pythia8	\
		   root-plugin-net-globus		\
		   root-plugin-net-bonjour		\
		   root-plugin-net-alien		\
		   root-plugin-net-srp			\
		   root-plugin-sql-maxdb		\
		   root-plugin-sql-mysql		\
		   root-plugin-sql-oracle		\
		   root-plugin-sql-pgsql		
PLUGINLIST	:= $(filter-out $(EXTRAS) $(ESSENTIALS), $(PKGLIST))
EXTRALIST	:= $(filter-out $(PLUGINS) $(ESSENTIALS), $(PKGLIST))
PLUGINLIST	:= $(PLUGINLIST:libroot%=libroot%-dev)
EXTRALIST	:= $(EXTRALIST:libroot%=libroot%-dev)
PLUGINHEAD	:= $(filter-out $(lastword $(PLUGINLIST)), $(PLUGINLIST))
PLUGINLIST	:= $(PLUGINHEAD:%=%,) $(lastword $(PLUGINLIST))
EXTRAHEAD	:= $(filter-out $(lastword $(EXTRALIST)), $(EXTRALIST))
EXTRALIST	:= $(EXTRAHEAD:%=%,) $(lastword $(EXTRALIST))
TEMPLATES	:= $(wildcard debian/skel/*.links.in) \
                   $(wildcard debian/skel/*.menu.in) \
                   $(wildcard debian/skel/*.prerm.in) \
                   $(wildcard debian/skel/*.preinst.in) \
                   $(wildcard debian/skel/*.postinst.in) \
                   $(wildcard debian/skel/*.init.in) \
                   $(wildcard debian/skel/*.desktop.in)
SPKGLIST	:= $(filter-out root-system-doc root-system-common ttf-root-installer, $(PKGLIST:libroot%=libroot%$(SOVERS))) $(filter libroot%, $(PKGLIST:libroot%=libroot%-dev)) libroot-static
IPKGLIST	:= root-system-doc ttf-root-installer root-system-common root-system
DPKGLIST	:= $(SPKGLIST:%=%,) root-system-doc, root-ttf
#root-plugins root-extra-plugins
SPKGOPTS	:= $(SPKGLIST:%=-p%) 
IPKGOPTS	:= $(IPKGLIST:%=-p%) 
PKGOPTS		:= $(IPKGOPTS) $(SPKGOPTS)
HAVERUBY	:= $(filter libroot-bindings-ruby, $(PKGLIST))
ifeq ($(HAVERUBY), libroot-bindings-ruby)
